unit UnidadVentanaNotificacion;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, AgBlend, Buttons, StdCtrls;

type
  TformNotificacionI = class(TForm)
    AgBlend1: TAgBlend;
    tmTransparenciaInicial: TTimer;
    bVer: TSpeedButton;
    tmCerrar: TTimer;
    tmTransparenciaCerrar: TTimer;
    tmActividad: TTimer;
    tmTransparenciaIncrementar: TTimer;
    lUsuario: TLabel;
    lDescripcion: TMemo;
    lAsunto: TLabel;
    lNumero: TLabel;
    bInfoUsuario: TSpeedButton;
    lPrioridad: TLabel;
    procedure tmTransparenciaInicialTimer(Sender: TObject);
    procedure lDescripcionMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure tmCerrarTimer(Sender: TObject);
    procedure tmTransparenciaCerrarTimer(Sender: TObject);
    procedure tmActividadTimer(Sender: TObject);
    procedure lPrioridadMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure bVerMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure tmTransparenciaIncrementarTimer(Sender: TObject);
    procedure bVerClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure lAsuntoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure bInfoUsuarioClick(Sender: TObject);
    procedure lUsuarioMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    hayActividad : boolean;
  public
    { Public declarations }
  end;

var
  formNotificacionI: TformNotificacionI;

implementation

uses UnidadMenuPrincipal;


{$R *.dfm}

procedure TformNotificacionI.tmTransparenciaInicialTimer(Sender: TObject);
begin
  if AgBlend1.Opacity = 255 then
  begin
    tmTransparenciaInicial.Enabled := false;
    tmCerrar.Enabled := true;
    tmActividad.Enabled := true;
  end;
  AgBlend1.Opacity := AgBlend1.Opacity + 5;
  AgBlend1.Refresh;
end;

procedure TformNotificacionI.lDescripcionMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  hayActividad := true;
  lDescripcion.Cursor := crHandPoint;
  lDescripcion.Font.Style := [fsunderline];
end;

procedure TformNotificacionI.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  hayActividad := true;
  lDescripcion.Cursor := crDefault;
  lDescripcion.Font.Style := [];
  lAsunto.Cursor := crHandPoint;
  lAsunto.Font.Style := [fsbold];
  lAsunto.Cursor := crHandPoint;
  lUsuario.Font.Style := [fsbold];
end;

procedure TformNotificacionI.tmCerrarTimer(Sender: TObject);
begin
  if not hayActividad then
    tmTransparenciaCerrar.Enabled := true;
end;

procedure TformNotificacionI.tmTransparenciaCerrarTimer(Sender: TObject);
begin
  if hayActividad then
  begin
    tmTransparenciaCerrar.Enabled := false;
    tmTransparenciaIncrementar.Enabled := true;
  end
  else
  begin
    if AgBlend1.Opacity = 0 then
      close;
    AgBlend1.Opacity := AgBlend1.Opacity - 5;
    AgBlend1.Refresh;
  end;
end;

procedure TformNotificacionI.tmActividadTimer(Sender: TObject);
var
  posicionRaton : TPoint;
begin
  GetCursorPos (posicionRaton);
  if (posicionRaton.Y > Top + formNotificacionI.Height) or
     (posicionRaton.Y < Top) or
     (posicionRaton.X > Left + formNotificacionI.Width) or
     (posicionRaton.X < Left) then
    hayActividad := false
  else
    hayActividad := true;
end;

procedure TformNotificacionI.lPrioridadMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  hayActividad := true;
end;

procedure TformNotificacionI.bVerMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  hayActividad := true;
end;

procedure TformNotificacionI.tmTransparenciaIncrementarTimer(
  Sender: TObject);
begin
  if AgBlend1.Opacity = 255 then
  begin
    tmTransparenciaIncrementar.Enabled := false;
    tmCerrar.Enabled := true;
    tmActividad.Enabled := true;
  end;
  AgBlend1.Opacity := AgBlend1.Opacity + 5;
  AgBlend1.Refresh;
end;

procedure TformNotificacionI.bVerClick(Sender: TObject);
begin
  formMenuPrincipal.vtNotificacionMostrada := true;
  ShowMessage('Has pulsado el botn "Informacin incidencia"');
end;

procedure TformNotificacionI.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  formMenuPrincipal.vtNotificacionMostrada := false;
  Action := caFree;
end;

procedure TformNotificacionI.FormShow(Sender: TObject);
begin
  lDescripcion.Font.Color := clBlue;
  formMenuPrincipal.vtnotificacionMostrada := true;
  hayActividad := false;
  formNotificacionI.Left := Screen.Width - formNotificacionI.Width - 5;
  formNotificacionI.Top := Screen.Height - formNotificacionI.Height - 30;
  AgBlend1.Opacity := 0;
  AgBlend1.BlendType := Alpha;
  AgBlend1.Refresh;

  tmTransparenciaInicial.Enabled := true;
end;

procedure TformNotificacionI.lAsuntoMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  hayActividad := true;
  lAsunto.Cursor := crHandPoint;
  lAsunto.Font.Style := [fsunderline, fsbold];
end;

procedure TformNotificacionI.bInfoUsuarioClick(Sender: TObject);
begin
  ShowMessage('Has pulsado el botn "Informacin usuario"');
end;

procedure TformNotificacionI.lUsuarioMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  hayActividad := true;
  lUsuario.Cursor := crHandPoint;
  lUsuario.Font.Style := [fsunderline, fsbold];
end;

end.
