(************************************************************
Author: Deepak Shenoy
        shenoy@agnisoft.com
Copyright (C) 2000 Agni Software Pvt. Ltd.
All Rights Reserved.
http://www.agnisoft.com

AgBlend Version 0.9 - Demo Project

Run this project (will not work on anything but Win2000) and
check out what the properties can do.

Set the Transparent color to clTeal and then Blend Type to 
ColorKey and check it out!
********************************************************)

unit DemoForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AgBlend, jpeg, ExtCtrls, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    AgBlend1: TAgBlend;
    Image1: TImage;
    Label1: TLabel;
    rgBlendType: TRadioGroup;
    lblBlendValue: TLabel;
    chbAutoSet: TCheckBox;
    edtColor: TEdit;
    Color: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ColorDialog1: TColorDialog;
    Button4: TButton;
    Timer1: TTimer;
    cbColors: TComboBox;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure rgBlendTypeClick(Sender: TObject);
    procedure edtColorExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure cbColorsChange(Sender: TObject);
    procedure chbAutoSetClick(Sender: TObject);
  private
    { Private declarations }
    procedure AutoCheck;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  with AgBlend1 do
  begin
    AgBlend1.Refresh;
    if not chbAutoset.Checked then
      chbAutoset.Checked := TRUE
  end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  lblBlendValue.Caption := IntToStr(TrackBar1.Position);
  AgBlend1.Opacity := TrackBar1.Position;
end;

procedure TForm1.rgBlendTypeClick(Sender: TObject);
begin
  with AgBlend1 do
    case rgBlendType.ItemIndex of
    0:  BlendType := Alpha;
    1:  BlendType := ColorKey;
    2:  BlendType := Opaque;
    end;
end;

procedure TForm1.AutoCheck;
begin
  if chbAutoset.Checked then
    AgBlend1.Refresh;
end;

procedure TForm1.edtColorExit(Sender: TObject);
var iNewVal : integer;
begin
  try
    AgBlend1.TransparentColor := iNewVal;
  except
    AgBlend1.TransparentColor := 0;
    edtColor.Text := '0';
  end;

end;

const
  Colors: array[0..41] of TIdentMapEntry = (
    (Value: clBlack; Name: 'clBlack'),
    (Value: clMaroon; Name: 'clMaroon'),
    (Value: clGreen; Name: 'clGreen'),
    (Value: clOlive; Name: 'clOlive'),
    (Value: clNavy; Name: 'clNavy'),
    (Value: clPurple; Name: 'clPurple'),
    (Value: clTeal; Name: 'clTeal'),
    (Value: clGray; Name: 'clGray'),
    (Value: clSilver; Name: 'clSilver'),
    (Value: clRed; Name: 'clRed'),
    (Value: clLime; Name: 'clLime'),
    (Value: clYellow; Name: 'clYellow'),
    (Value: clBlue; Name: 'clBlue'),
    (Value: clFuchsia; Name: 'clFuchsia'),
    (Value: clAqua; Name: 'clAqua'),
    (Value: clWhite; Name: 'clWhite'),
    (Value: clScrollBar; Name: 'clScrollBar'),
    (Value: clBackground; Name: 'clBackground'),
    (Value: clActiveCaption; Name: 'clActiveCaption'),
    (Value: clInactiveCaption; Name: 'clInactiveCaption'),
    (Value: clMenu; Name: 'clMenu'),
    (Value: clWindow; Name: 'clWindow'),
    (Value: clWindowFrame; Name: 'clWindowFrame'),
    (Value: clMenuText; Name: 'clMenuText'),
    (Value: clWindowText; Name: 'clWindowText'),
    (Value: clCaptionText; Name: 'clCaptionText'),
    (Value: clActiveBorder; Name: 'clActiveBorder'),
    (Value: clInactiveBorder; Name: 'clInactiveBorder'),
    (Value: clAppWorkSpace; Name: 'clAppWorkSpace'),
    (Value: clHighlight; Name: 'clHighlight'),
    (Value: clHighlightText; Name: 'clHighlightText'),
    (Value: clBtnFace; Name: 'clBtnFace'),
    (Value: clBtnShadow; Name: 'clBtnShadow'),
    (Value: clGrayText; Name: 'clGrayText'),
    (Value: clBtnText; Name: 'clBtnText'),
    (Value: clInactiveCaptionText; Name: 'clInactiveCaptionText'),
    (Value: clBtnHighlight; Name: 'clBtnHighlight'),
    (Value: cl3DDkShadow; Name: 'cl3DDkShadow'),
    (Value: cl3DLight; Name: 'cl3DLight'),
    (Value: clInfoText; Name: 'clInfoText'),
    (Value: clInfoBk; Name: 'clInfoBk'),
    (Value: clNone; Name: 'clNone'));

procedure TForm1.FormCreate(Sender: TObject);
var l : longint;
begin
  l := GetWindowLong( edtColor.Handle, GWL_STYLE);
  l := l or ES_NUMBER;
  SetWindowLong( edtColor.Handle, GWL_STYLE, l );

  for l := Low(Colors) to High(Colors) do
  begin
    cbColors.Items.AddObject(Colors[l].Name, TObject(Colors[l].Value));
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  try
    ColorDialog1.Color :=StrToInt(edtColor.Text);
  except
    ColorDialog1.Color := 0;
    edtColor.Text := '0';
  end;

  if ColorDialog1.Execute then
    edtColor.Text := IntToStr(ColorDialog1.Color);

  AutoCheck;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  AgBlend1.Opacity := 0;
  AgBlend1.BlendType := Alpha;
  AgBlend1.Refresh;

  Timer1.Enabled := TRUE;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if AgBlend1.Opacity = 255 then
    Timer1.Enabled := FALSE;
  AgBlend1.Opacity := AgBlend1.Opacity + 5;
  AgBlend1.Refresh;
end;

procedure TForm1.cbColorsChange(Sender: TObject);
begin
  AgBlend1.TransparentColor := Integer( cbColors.Items.Objects[cbColors.ItemIndex] );
  edtColor.Text := IntToStr( AgBlend1.TransparentColor );

end;

procedure TForm1.chbAutoSetClick(Sender: TObject);
begin
  AgBlend1.Active := chbAutoSet.Checked;
end;

end.
